package com.app.imagedrawer;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Rect;



public class ScreenFrame {

private static final int MAP_FRAME_WIDTH = 240;
private static final int MAP_FRAME_HEIGHT = 320;
private static final int FRAME_WIMDOW_WIDTH_COUNT = 3;
private static final int FRAME_WIMDOW_HEIGHT_COUNT = 3;
private static final int MAP_SLICE_WIDTH = 255;
private static final int MAP_SLICE_HEIGHT = 255;
private static final int MAP_IMG_WIDTH = 6120;
private static final int MAP_IMG_HEIGHT = 8448;


private	int Width;
private	int Height;

private	int SliceWidth;
private	int SliceHeight;


private	int OffsetX;
private	int OffsetY;

private	boolean isLoaded;

int[][] mSliceLoaded = new int[FRAME_WIMDOW_WIDTH_COUNT][FRAME_WIMDOW_HEIGHT_COUNT];
public Bitmap[][] mBitmap = new Bitmap[FRAME_WIMDOW_WIDTH_COUNT][FRAME_WIMDOW_HEIGHT_COUNT];



public ScreenFrame()
 {
	Width = MAP_FRAME_WIDTH;
	Height = MAP_FRAME_HEIGHT;

	SliceWidth = MAP_SLICE_WIDTH;
	SliceHeight = MAP_SLICE_HEIGHT;

	OffsetX = 0;
	OffsetY = 0;

	isLoaded = false;
	
	
	for (int i=0; i< FRAME_WIMDOW_WIDTH_COUNT; i++)
		for (int j=0; j< FRAME_WIMDOW_HEIGHT_COUNT; j++)
		{
			mSliceLoaded[i][j] = -1;
		}

 }

public boolean LoadFrame( int nX, int nY, int cX, int cY)
 {
	int slice;
	String str="";
	int i, j, x, y;

	for( i=0, x=nX; i < FRAME_WIMDOW_WIDTH_COUNT && x < (nX+cX); i++, x++)
		for( j=0, y=nY; j < FRAME_WIMDOW_HEIGHT_COUNT && y < (nY+cY); j++, y++)
		{
			slice = y * ( MAP_IMG_WIDTH / SliceWidth ) + x + 1;	// +1 if picture start named from 1
			if(mSliceLoaded[i][j] != slice)
			{
				if(slice < 9)
					str = "/sdcard/gif/SPbMap_0" + slice + ".gif";
				else
					str = "/sdcard/gif/SPbMap_" + slice + ".gif";

				mBitmap[i][j] = BitmapFactory.decodeFile(str);
				mSliceLoaded[i][j] = slice;
			}
		}

	return false;
 }



boolean DrawFrames(Canvas _canvas, Paint _paint, int offsetX, int offsetY)
 {
	int i, j;
	Rect src = new Rect(0, 0, SliceHeight*3, SliceWidth*3);
	Rect dst = new Rect(0,0,0,0);

	for( i=0; i < FRAME_WIMDOW_WIDTH_COUNT; i++)
		for( j=0; j < FRAME_WIMDOW_HEIGHT_COUNT; j++)
		{
			// src.set(0, 0, SliceHeight, SliceWidth);
			dst.set(i*SliceWidth + offsetX, j*SliceHeight  + offsetY,
					i*SliceWidth+SliceWidth + offsetX, j*SliceHeight+SliceHeight + offsetY);
			_canvas.drawBitmap(mBitmap[i][j], src, dst, _paint);
		}

	return false;
 }

boolean MoveFrame(Canvas _canvas, Paint _paint, int x, int y)
 {
	int nX = -x / SliceWidth;
	int nY = -y / SliceHeight;
	int offsX = x % SliceWidth;
	int offsY = y % SliceHeight;
	
	LoadFrame( nX, nY, FRAME_WIMDOW_WIDTH_COUNT, FRAME_WIMDOW_HEIGHT_COUNT);
	DrawFrames( _canvas, _paint, offsX, offsY);

	return false;
 }

}


